From: Chao Yu <chao@kernel.org>
To: fstests@vger.kernel.org
Cc: guaneryu@gmail.com, linux-f2fs-devel@lists.sourceforge.net,
Chao Yu <yuchao0@huawei.com>
Subject: [PATCH v2 1/3] generic: test project id recovery after power failure
Date: Sun, 7 Oct 2018 20:25:46 +0800 [thread overview]
Message-ID: <20181007122548.21876-1-chao@kernel.org> (raw)
From: Chao Yu <yuchao0@huawei.com>
After fsync, filesystem should guarantee inode metadata including
project id being persisted, so even after sudden power-cut, during
mount, we should recover project_id fields correctly, in order to
not loss those meta info.
So adding this testcase to check whether generic filesystem can
guarantee that.
Signed-off-by: Chao Yu <yuchao0@huawei.com>
---
v2:
- export and use $LSATTR_PROG in common/rc
- use $CHATTR_PROG instead of chattr
- fix wrong comments
- add -f parameter for rm
common/config | 1 +
tests/generic/506 | 97 +++++++++++++++++++++++++++++++++++++++++++
tests/generic/506.out | 2 +
tests/generic/group | 1 +
4 files changed, 101 insertions(+)
create mode 100755 tests/generic/506
create mode 100644 tests/generic/506.out
diff --git a/common/config b/common/config
index 1ba8d96c..a87cb4a2 100644
--- a/common/config
+++ b/common/config
@@ -170,6 +170,7 @@ export WIPEFS_PROG="$(type -P wipefs)"
export DUMP_PROG="$(type -P dump)"
export RESTORE_PROG="$(type -P restore)"
export LVM_PROG="$(type -P lvm)"
+export LSATTR_PROG="$(type -P lsattr)"
export CHATTR_PROG="$(type -P chattr)"
export DEBUGFS_PROG="$(type -P debugfs)"
export UUIDGEN_PROG="$(type -P uuidgen)"
diff --git a/tests/generic/506 b/tests/generic/506
new file mode 100755
index 00000000..5d419cad
--- /dev/null
+++ b/tests/generic/506
@@ -0,0 +1,97 @@
+#! /bin/bash
+# SPDX-License-Identifier: GPL-2.0
+# Copyright (c) 2018 Huawei. All Rights Reserved.
+#
+# FS QA Test 506
+#
+# This testcase is trying to test recovery flow of generic filesystem, w/ below
+# steps, once project id changes, after we fsync that file, we can expect that
+# project id can be recovered after sudden power-cuts.
+# 1. touch testfile;
+# 1.1 sync (optional)
+# 2. chattr -p 100 testfile;
+# 3. xfs_io -f testfile -c "fsync";
+# 4. godown;
+# 5. umount;
+# 6. mount;
+# 7. check project id
+#
+seq=`basename $0`
+seqres=$RESULT_DIR/$seq
+echo "QA output created by $seq"
+
+here=`pwd`
+tmp=/tmp/$$
+status=1 # failure is the default!
+trap "_cleanup; exit \$status" 0 1 2 3 15
+
+_cleanup()
+{
+ cd /
+ rm -f $tmp.*
+}
+
+# get standard environment, filters and checks
+. ./common/rc
+. ./common/filter
+. ./common/quota
+
+# remove previous $seqres.full before test
+rm -f $seqres.full
+
+# real QA test starts here
+_supported_fs generic
+_supported_os Linux
+
+_require_command "$LSATTR_PROG" lsattr
+_require_command "$CHATTR_PROG" chattr
+
+_require_prjquota $SCRATCH_DEV
+_require_scratch
+_require_scratch_shutdown
+
+_scratch_mkfs >/dev/null 2>&1
+_require_metadata_journaling $SCRATCH_DEV
+
+testfile=$SCRATCH_MNT/testfile
+
+do_check()
+{
+ _scratch_mount
+
+ touch $testfile
+
+ if [ "$1" == "sync" ]; then
+ sync
+ fi
+
+ $CHATTR_PROG -p 100 $testfile
+
+ before=`$LSATTR_PROG -p $testfile`
+
+ $XFS_IO_PROG -f $testfile -c "fsync" | _filter_xfs_io
+
+ _scratch_shutdown | tee -a $seqres.full
+ _scratch_cycle_mount
+
+ after=`$LSATTR_PROG -p $testfile`
+
+ # check inode's project quota id
+ if [ "$before" != "$after" ]; then
+ echo "Before: $before"
+ echo "After : $after"
+ fi
+ echo "Before: $before" >> $seqres.full
+ echo "After : $after" >> $seqres.full
+
+ rm -f $testfile
+ _scratch_unmount
+}
+
+echo "Silence is golden"
+
+do_check
+do_check sync
+
+status=0
+exit
diff --git a/tests/generic/506.out b/tests/generic/506.out
new file mode 100644
index 00000000..cb46b201
--- /dev/null
+++ b/tests/generic/506.out
@@ -0,0 +1,2 @@
+QA output created by 506
+Silence is golden
diff --git a/tests/generic/group b/tests/generic/group
index 4da0e188..c7d42ff9 100644
--- a/tests/generic/group
+++ b/tests/generic/group
@@ -508,3 +508,4 @@
503 auto quick dax punch collapse zero
504 auto quick locks
505 shutdown auto quick metadata
+506 shutdown auto quick metadata quota
--
2.18.0
WARNING: multiple messages have this Message-ID (diff)
From: Chao Yu <chao@kernel.org>
To: fstests@vger.kernel.org
Cc: guaneryu@gmail.com, linux-f2fs-devel@lists.sourceforge.net
Subject: [PATCH v2 1/3] generic: test project id recovery after power failure
Date: Sun, 7 Oct 2018 20:25:46 +0800 [thread overview]
Message-ID: <20181007122548.21876-1-chao@kernel.org> (raw)
From: Chao Yu <yuchao0@huawei.com>
After fsync, filesystem should guarantee inode metadata including
project id being persisted, so even after sudden power-cut, during
mount, we should recover project_id fields correctly, in order to
not loss those meta info.
So adding this testcase to check whether generic filesystem can
guarantee that.
Signed-off-by: Chao Yu <yuchao0@huawei.com>
---
v2:
- export and use $LSATTR_PROG in common/rc
- use $CHATTR_PROG instead of chattr
- fix wrong comments
- add -f parameter for rm
common/config | 1 +
tests/generic/506 | 97 +++++++++++++++++++++++++++++++++++++++++++
tests/generic/506.out | 2 +
tests/generic/group | 1 +
4 files changed, 101 insertions(+)
create mode 100755 tests/generic/506
create mode 100644 tests/generic/506.out
diff --git a/common/config b/common/config
index 1ba8d96c..a87cb4a2 100644
--- a/common/config
+++ b/common/config
@@ -170,6 +170,7 @@ export WIPEFS_PROG="$(type -P wipefs)"
export DUMP_PROG="$(type -P dump)"
export RESTORE_PROG="$(type -P restore)"
export LVM_PROG="$(type -P lvm)"
+export LSATTR_PROG="$(type -P lsattr)"
export CHATTR_PROG="$(type -P chattr)"
export DEBUGFS_PROG="$(type -P debugfs)"
export UUIDGEN_PROG="$(type -P uuidgen)"
diff --git a/tests/generic/506 b/tests/generic/506
new file mode 100755
index 00000000..5d419cad
--- /dev/null
+++ b/tests/generic/506
@@ -0,0 +1,97 @@
+#! /bin/bash
+# SPDX-License-Identifier: GPL-2.0
+# Copyright (c) 2018 Huawei. All Rights Reserved.
+#
+# FS QA Test 506
+#
+# This testcase is trying to test recovery flow of generic filesystem, w/ below
+# steps, once project id changes, after we fsync that file, we can expect that
+# project id can be recovered after sudden power-cuts.
+# 1. touch testfile;
+# 1.1 sync (optional)
+# 2. chattr -p 100 testfile;
+# 3. xfs_io -f testfile -c "fsync";
+# 4. godown;
+# 5. umount;
+# 6. mount;
+# 7. check project id
+#
+seq=`basename $0`
+seqres=$RESULT_DIR/$seq
+echo "QA output created by $seq"
+
+here=`pwd`
+tmp=/tmp/$$
+status=1 # failure is the default!
+trap "_cleanup; exit \$status" 0 1 2 3 15
+
+_cleanup()
+{
+ cd /
+ rm -f $tmp.*
+}
+
+# get standard environment, filters and checks
+. ./common/rc
+. ./common/filter
+. ./common/quota
+
+# remove previous $seqres.full before test
+rm -f $seqres.full
+
+# real QA test starts here
+_supported_fs generic
+_supported_os Linux
+
+_require_command "$LSATTR_PROG" lsattr
+_require_command "$CHATTR_PROG" chattr
+
+_require_prjquota $SCRATCH_DEV
+_require_scratch
+_require_scratch_shutdown
+
+_scratch_mkfs >/dev/null 2>&1
+_require_metadata_journaling $SCRATCH_DEV
+
+testfile=$SCRATCH_MNT/testfile
+
+do_check()
+{
+ _scratch_mount
+
+ touch $testfile
+
+ if [ "$1" == "sync" ]; then
+ sync
+ fi
+
+ $CHATTR_PROG -p 100 $testfile
+
+ before=`$LSATTR_PROG -p $testfile`
+
+ $XFS_IO_PROG -f $testfile -c "fsync" | _filter_xfs_io
+
+ _scratch_shutdown | tee -a $seqres.full
+ _scratch_cycle_mount
+
+ after=`$LSATTR_PROG -p $testfile`
+
+ # check inode's project quota id
+ if [ "$before" != "$after" ]; then
+ echo "Before: $before"
+ echo "After : $after"
+ fi
+ echo "Before: $before" >> $seqres.full
+ echo "After : $after" >> $seqres.full
+
+ rm -f $testfile
+ _scratch_unmount
+}
+
+echo "Silence is golden"
+
+do_check
+do_check sync
+
+status=0
+exit
diff --git a/tests/generic/506.out b/tests/generic/506.out
new file mode 100644
index 00000000..cb46b201
--- /dev/null
+++ b/tests/generic/506.out
@@ -0,0 +1,2 @@
+QA output created by 506
+Silence is golden
diff --git a/tests/generic/group b/tests/generic/group
index 4da0e188..c7d42ff9 100644
--- a/tests/generic/group
+++ b/tests/generic/group
@@ -508,3 +508,4 @@
503 auto quick dax punch collapse zero
504 auto quick locks
505 shutdown auto quick metadata
+506 shutdown auto quick metadata quota
--
2.18.0
next reply other threads:[~2018-10-07 22:04 UTC|newest]
Thread overview: 6+ messages / expand[flat|nested] mbox.gz Atom feed top
2018-10-07 12:25 Chao Yu [this message]
2018-10-07 12:25 ` [PATCH v2 1/3] generic: test project id recovery after power failure Chao Yu
2018-10-07 12:25 ` [PATCH v2 2/3] generic: test i_flags " Chao Yu
2018-10-07 12:25 ` Chao Yu
2018-10-07 12:25 ` [PATCH v2 3/3] generic: test creation time " Chao Yu
2018-10-07 12:25 ` Chao Yu
Reply instructions:
You may reply publicly to this message via plain-text email
using any one of the following methods:
* Save the following mbox file, import it into your mail client,
and reply-to-all from there: mbox
Avoid top-posting and favor interleaved quoting:
https://en.wikipedia.org/wiki/Posting_style#Interleaved_style
* Reply using the --to, --cc, and --in-reply-to
switches of git-send-email(1):
git send-email \
--in-reply-to=20181007122548.21876-1-chao@kernel.org \
--to=chao@kernel.org \
--cc=fstests@vger.kernel.org \
--cc=guaneryu@gmail.com \
--cc=linux-f2fs-devel@lists.sourceforge.net \
--cc=yuchao0@huawei.com \
/path/to/YOUR_REPLY
https://kernel.org/pub/software/scm/git/docs/git-send-email.html
* If your mail client supports setting the In-Reply-To header
via mailto: links, try the mailto: link
Be sure your reply has a Subject: header at the top and a blank line
before the message body.
This is an external index of several public inboxes,
see mirroring instructions on how to clone and mirror
all data and code used by this external index.